﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Data.SqlClient;

namespace ToolSystem
{
    public class Person
    {
        public int PersonId { get; set; }
        public string PersonName { get; set; }
        public string PersonTag { get; set; }
        public string EMail { get; set; }
        public string Password { get; set; }


        public List<Person> GetPersons(string connectionString)
        {

            List<Person> personList = new List<Person>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select PersonId, PersonName, PersonTag, EMail from PERSON";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Person person = new Person();

                    person.PersonId = Convert.ToInt32(dr["PersonId"]);
                    person.PersonName = dr["PersonName"].ToString();
                    person.PersonTag = dr["PersonTag"].ToString();
                    person.EMail = dr["EMail"].ToString();

                    personList.Add(person);
                }

            }

            return personList;
        }

        public void NewPerson(string connectionString, Person person)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("NewPerson", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonName", person.PersonName));
                    cmd.Parameters.Add(new SqlParameter("@PersonTag", person.PersonTag));
                    cmd.Parameters.Add(new SqlParameter("@EMail", person.EMail));
                    cmd.Parameters.Add(new SqlParameter("@Password", person.Password));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

        public Person GetPersonData(string connectionString, int personId)
        {

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select PersonId, PersonName, PersonTag, EMail  from PERSON where PersonId = " + personId;
            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            Person person = new Person();

            if (dr != null)
            {
                while (dr.Read())
                {
                    person.PersonId = Convert.ToInt32(dr["PersonId"]);
                    person.PersonName = dr["PersonName"].ToString();
                    person.PersonTag = dr["PersonTag"].ToString();
                    person.EMail = dr["EMail"].ToString();
                }
            }

            return person;
        }

        public void EditPerson(string connectionString, Person person)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("UpdatePerson", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonId", person.PersonId));
                    cmd.Parameters.Add(new SqlParameter("@PersonName", person.PersonName));
                    cmd.Parameters.Add(new SqlParameter("@PersonTag", person.PersonTag));
                    cmd.Parameters.Add(new SqlParameter("@EMail", person.EMail));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

        public void DeletePerson(string connectionString, int personId)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("DeletePerson", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonId", personId));


                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

    }
}
