﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.SqlClient;


namespace ToolSystem
{
    public class Rfid
    {

        /// Get ToolName from Database based on RFID Key
        public string GetToolName(string connectionString, string tagKey)
        {
            string toolName = "";

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select ToolName from TOOL where ToolTag = '" + tagKey + "'";
            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();


            if (dr != null)
            {
                while (dr.Read())
                {
                    toolName = dr["ToolName"].ToString();
                }
            }

            return toolName;

        }


        public string GetPersonName(string connectionString, string tagKey)
        {
            string personName = "";

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select PersonName from PERSON where PersonTag = '" + tagKey + "'";
            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();


            if (dr != null)
            {
                while (dr.Read())
                {
                    personName = dr["PersonName"].ToString();
                }
            }

            return personName;

        }




        public void SetToolStatus(string connectionString, string personTag, string toolTag)
        {

            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("SetToolStatus", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonTag", personTag));
                    cmd.Parameters.Add(new SqlParameter("@ToolTag", toolTag));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }


        }

        public void BorrowTool(string connectionString, string PersonTag, string ToolTag)
        {

            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("BorrowTool", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonTag", PersonTag));
                    cmd.Parameters.Add(new SqlParameter("@ToolTag", ToolTag));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }


        }


        public void ReturnTool(string connectionString, string ToolTag)
        {

            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("ReturnTool", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@ToolTag", ToolTag));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }


        }


    }
}
