using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Http;
using ToolSystem;

namespace Tool_Management.Pages
{
    public class BorrowToolModel : PageModel
    {
        readonly IConfiguration _configuration;

        public string connectionString;

        public int toolId;

        public int userId = 0;
        public string userName = null;
        public int validUser = 0;


        public BorrowToolModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            VerifyLogin();

            if (validUser==1)
                BorrowTool();

            Response.Redirect("./Tools");
        }


        void VerifyLogin()
        {

            if (HttpContext.Session.GetInt32("Login") != null)
                validUser = (int)HttpContext.Session.GetInt32("Login");
            else
                validUser = 0;

            if (HttpContext.Session.GetInt32("UserId") != null)
                userId = (int)HttpContext.Session.GetInt32("UserId");
            else
                userId = 0;

            if (HttpContext.Session.GetString("UserName") != null)
                userName = HttpContext.Session.GetString("UserName");
            else
                userName = null;
        }

        void BorrowTool()
        {
            toolId = Convert.ToInt32(Request.Query["toolid"]);

            connectionString = _configuration.GetConnectionString("ConnectionString");

            Tool tool = new Tool();

            tool.BorrowToolById(connectionString, userId, toolId);
        }

    }
}
