using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Http;
using ToolSystem;


namespace Tools.Pages
{
    public class ReserveModel : PageModel
    {
        readonly IConfiguration _configuration;

        public string connectionString;

        public int toolId;
        public string toolName;

        public int userId = 0;
        public string userName = null;
        public int validUser = 0;

        public ReserveModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            GetToolName();
        }

        public void OnPost()
        {
            VerifyLogin();

            if (validUser == 1)
                ReserveTool();
        }

        void GetToolName()
        {
            toolId = Convert.ToInt32(Request.Query["toolid"]);

            connectionString = _configuration.GetConnectionString("ConnectionString");

            Tool tool = new Tool();

            toolName = tool.GetToolName(connectionString, toolId);
        }


        void VerifyLogin()
        {

            if (HttpContext.Session.GetInt32("Login") != null)
                validUser = (int)HttpContext.Session.GetInt32("Login");
            else
                validUser = 0;

            if (HttpContext.Session.GetInt32("UserId") != null)
                userId = (int)HttpContext.Session.GetInt32("UserId");
            else
                userId = 0;

            if (HttpContext.Session.GetString("UserName") != null)
                userName = HttpContext.Session.GetString("UserName");
            else
                userName = null;
        }

        void ReserveTool()
        {
            toolId = Convert.ToInt32(Request.Query["toolid"]);

            connectionString = _configuration.GetConnectionString("ConnectionString");

            Tool tool = new Tool();

            tool.BorrowToolById(connectionString, userId, toolId);
        }
    }
}
