using System;
using System.Collections.Generic;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using ToolSystem;

namespace Tool_Management.Pages
{
    public class ToolsModel : PageModel
    {
        readonly IConfiguration _configuration;

        public List<Tool> tools = new List<Tool>();

        public string connectionString;

        public ToolsModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            tools = GetToolList();
        }

        private List<Tool> GetToolList()
        {
            connectionString = _configuration.GetConnectionString("ConnectionString");

            List<Tool> toolList = new List<Tool>();

            Tool tool = new Tool();

            toolList = tool.GetTools(connectionString);

            return toolList;
        }
    }
}
